local Gnoll = _G.Gnoll
local GL = Gnoll.Locale
local GLW = Gnoll.WoWLocale
local GD = Gnoll.Data


local function hideWishList()
	ItemFrameButton:Hide()
	WishFrameButton:Show()
	ItemFrame:Show()
	WishFrame:Hide()
end


local function checkitems()
	local leer = false
	for i=1, 30 do
		if ItemButtons[i]:IsShown() == true then		
			if ItemButtons[i]:GetText() == "Getting ItemInfo" then
				leer = true
			end
		end
	end
	
	if leer == true then
		local kontinent = tonumber(DDME["selectedID"])
		local instanz  = tonumber(DDMI["selectedID"])
		local dif = tonumber(DDMD["selectedValue"]) or 0
		local class = tonumber(DDMC["selectedValue"]) or 0
		local spec = tonumber(DDMS["selectedValue"]) or 0
		local instid = GD["Instanzen"][kontinent][instanz]
		local encounter = GD["Bosse"][kontinent][instanz][boss]
		if encounter == 1452 then dif = 15 end ---Special Fix fr Weltbossdingens 
		LootAbfrage(kontinent,dif,instid,encounter,class,spec,UpdateItems)
	end
end

local function checkitemscache()
	local leercache = false
	for i=1, 30 do
		if ItemButtons[i]:IsShown() == true then		
			if ItemButtons[i]:GetText() == "Getting ItemInfo" then
				leercache = true
			end
		end
	end
	
	if leercache == true then
		ClearItemButtons()
		GetItemCache(cacheliste,UpdateItems)
	end
end

local function LootAbfrageStart(arg1)
	if arg1 == "first" then boss = 1 else boss = tonumber(DDMB["selectedID"]) end
	local kontinent = tonumber(DDME["selectedID"])
	local instanz  = tonumber(DDMI["selectedID"])
	local dif = tonumber(DDMD["selectedValue"]) or 0
	local class = tonumber(DDMC["selectedValue"]) or 0
	local spec = tonumber(DDMS["selectedValue"]) or 0
	
	if instanz > #GD["Instanzen"][kontinent] then
		tmpI = instanz - #GD["Instanzen"][kontinent]
		local numloot = #GD["ModulLoot"][kontinent][tmpI][boss]
		local loot = GD["ModulLoot"][kontinent][tmpI][boss]
		cacheliste = { }
		itemliste = { }
		ClearCache()
		local itemcounter = 1
		for i = 1, numloot do
			local v = loot[i]
			if string.find(v,"t###") ~= nil then
				local _, start = string.find(v,"t###")
				table.insert(cacheliste,v)
			else -- es ist kein trenner drin also wird es ein Item sein.
				local _, p = string.find(v,"p###%d")
				local _, w = string.find(v,"w###%d")
				if  p ~= nil and w ~= nil then -- item mit Preis und Whrung nischt Gratis !
					local x, link = nil, nil
					local itemid = string.sub(v, 0, p-5)
					local preis = string.sub(v, p, w-5)
					local curency = string.sub(v, w)
					---doppelwhrung hh inkl. schreibfehler
						if string.find(curency,"p###") ~= nil then
							local _, p2 = string.find(curency,"p###%d")
							local _, w2 = string.find(curency,"w###%d")
							local preis2 = string.sub(curency, p2, w2-5)
							local curency2 = string.sub(curency, w2)
							curency = string.sub(curency, 0, p2-5)
							curency = { curency,curency2 }
							preis = { preis, preis2 }
						end
					--"itemName", "itemLink", itemRarity, itemLevel, itemMinLevel, "itemType", "itemSubType", itemStackCount, "itemEquipLoc", "invTexture", "itemSellPrice" 
					local insert = { itemid,preis,curency }
					table.insert(cacheliste,insert)
					itemliste[itemcounter] = { }
					itemliste[itemcounter]["itemid"] = itemid
					itemliste[itemcounter]["preis"] = preis
					itemliste[itemcounter]["curency"] = curency
					itemcounter = itemcounter +1 
				else --- Item ohne sonstige angaben
					local itemid = v
					table.insert(cacheliste,itemid)
					itemliste[itemcounter] = { }
					itemliste[itemcounter]["itemid"] = itemid
					itemcounter = itemcounter +1 
				end	 -- ende Gratis Item
			end --ende Kein Trenner
		end --ende FOR
		ClearItemButtons()
		GetItemCache(cacheliste,UpdateItems)
		C_Timer.After(0.5, checkitemscache)
	else --- kein Modul
		local instid = GD["Instanzen"][kontinent][instanz]
		local encounter = GD["Bosse"][kontinent][instanz][boss]
		if encounter == 1452 then dif = 15 end ---Special Fix fr Weltbossdingens 
		LootAbfrage(kontinent,dif,instid,encounter,class,spec,UpdateItems)
		C_Timer.After(0.5, checkitems)
	end
end

-----------------------------------------------------------------
----------------------------------------------------------------- E
-----------------------------------------------------------------

local function OnClickDDME(self)                --- Kontinent wurde ausgewhlt Instanz Dingens wird erstellt
	ClearItemButtons()
    UIDropDownMenu_SetSelectedID(DDME, self:GetID())
    UIDropDownMenu_SetText(DDMI, GL["Instance"], 0)
    UIDropDownMenu_SetText(DDMB, GL["Boss"], 0)
	hideWishList()
end

local function initializeDDME(self, level)      --- Addons werden aufgelistet
	local info = UIDropDownMenu_CreateInfo()  
	for k,v in pairs(GD["Addons"]) do
		info = UIDropDownMenu_CreateInfo()
		info.text = v
		info.value = v
		info.func = OnClickDDME
		UIDropDownMenu_AddButton(info, level)
	end
end
UIDropDownMenu_Initialize(DDME, initializeDDME)

-----------------------------------------------------------------
-----------------------------------------------------------------
----------------------------------------------------------------- D

local function OnClickDDMD(self,event,arg1)                --- Difficu
    UIDropDownMenu_SetSelectedID(DDMD, self:GetID())
	DDMD["selectedValue"] = self.value
	ClearItemButtons()
	LootAbfrageStart()
	hideWishList()
end

local function initializeDDMD(self, level)          -- Specs  Wird genereirt  (muss leider hier stehen :-()
    local info = UIDropDownMenu_CreateInfo()  
    local tmpE = DDME["selectedID"]
    local tmpI = DDMI["selectedID"]
    for k,v in pairs(GD["Difficulty"][tmpE][tmpI]) do
        info = UIDropDownMenu_CreateInfo()
        info.text = GLW["Difficulty"][v]
        info.value = v
        info.func = OnClickDDMD
        UIDropDownMenu_AddButton(info,1)
    end
end

-----------------------------------------------------------------
----------------------------------------------------------------- B
-----------------------------------------------------------------

local function OnClickDDMB(self)                --- Boss/Fraktion  wurde ausgewhlt
	UIDropDownMenu_SetSelectedID(DDMB, self:GetID())
	local tmpE = DDME["selectedID"]
	local tmpI = DDMI["selectedID"]
	if tmpI > #GD["Instanzen"][tmpE] then
		ClearItemButtons()
		LootAbfrageStart()
		hideWishList()
	else
		ClearItemButtons()
		LootAbfrageStart()
		hideWishList()
	end
end
 
local function initializeDDMB(self, level)          -- Bosse werden aufgelistet
    local info = UIDropDownMenu_CreateInfo()  
    local tmpE = DDME["selectedID"]
    local tmpI = DDMI["selectedID"]
	local tmpM = tmpI - #GD["Instanzen"][tmpE]
	if tmpI > #GD["Instanzen"][tmpE] then	-- Moduldaten
		for k,v in pairs(GD["ModulData"][tmpE][tmpM]) do
			info = UIDropDownMenu_CreateInfo()
			if string.find(v,"f###") ~= nil then
				local _, start = string.find(v,"f###")
				local id = string.sub(v, start+1)
				v = GetFactionInfoByID(id)
			elseif string.find(v,"e###") ~= nil then
				local _, start = string.find(v,"e###")
				local id = string.sub(v, start+1)
				v = EJ_GetEncounterInfo(id)
			end
			info.text = v
			info.value = v
			info.func = OnClickDDMB
			UIDropDownMenu_AddButton(info, level)
		end
	else	--normale daten
		for k,v in pairs(GD["Bosse"][tmpE][tmpI]) do
			info = UIDropDownMenu_CreateInfo()
			if type(v) == "number" then
				info.text = EJ_GetEncounterInfo(v)
			else
				info.text = v.."!!!"
			end
			info.value = v
			info.func = OnClickDDMB
			UIDropDownMenu_AddButton(info, level)
		end
	end
	
	
end

-----------------------------------------------------------------
----------------------------------------------------------------- I
-----------------------------------------------------------------

local function OnClickDDMI(self)                --- Instanz wurde ausgewhlt
    UIDropDownMenu_SetSelectedID(DDMI, self:GetID())
	local tmpE = DDME["selectedID"]
    local tmpI = DDMI["selectedID"]
	UIDropDownMenu_Initialize(DDMB, initializeDDMB)
	if tmpI > #GD["Instanzen"][tmpE] then		-- ModulData
		local tmpM = tmpI - #GD["Instanzen"][tmpE] 
		UIDropDownMenu_SetText(DDMB, GL["Factions"], 0)
		local firstfrac = GD["ModulData"][tmpE][tmpM][1]
		DDMB["selectedID"] = 1
		UIDropDownMenu_SetSelectedID(DDMB, 1)
		if string.find(firstfrac,"f###") ~= nil then
			local _, start = string.find(firstfrac,"f###")
			local id = string.sub(firstfrac, start+1)
			firstfrac = GetFactionInfoByID(id)
		elseif string.find(firstfrac,"e###") ~= nil then
			local _, start = string.find(firstfrac,"e###")
			local id = string.sub(firstfrac, start+1)
			firstfrac = EJ_GetEncounterInfo(id)
		end
		UIDropDownMenu_SetText(DDMB, firstfrac) 
		ClearItemButtons()
		LootAbfrageStart()
		hideWishList()
		DDMD:Hide()
		DDMS:Hide()
		DDMC:Hide()
	else  -- Normaler Kram 
		DDMD:Show()
		DDMS:Show()
		DDMC:Show()
		if GD["MapIDS"][tmpE][tmpI] == GL["World Bosses"] then 
			DDMD:Hide()
		end
		
		UIDropDownMenu_SetText(DDMB, GL["Boss"], 0) --> Bossbeschriftung
		UIDropDownMenu_Initialize(DDMD, initializeDDMD) -->Aufruf Difficulty zu erzeugen
		local firstdiff = GD["Difficulty"][tmpE][tmpI][1]    -- erste verfgbare diff.
		DDMD["selectedID"] = firstdiff  --
		UIDropDownMenu_SetSelectedValue(DDMD, firstdiff, firstdiff)--
		UIDropDownMenu_SetText(DDMD, GLW["Difficulty"][firstdiff]) -- Diff
		local firstboss = GD["Bosse"][tmpE][tmpI][1] --- erster boss wird ausgewhlt
		UIDropDownMenu_SetSelectedID(DDMB, 1)
		UIDropDownMenu_SetText(DDMB, EJ_GetEncounterInfo(firstboss))
		ClearItemButtons()
		LootAbfrageStart("first")
		hideWishList()
	end
end

local function initializeDDMI(self, level)          -- Instanzen werden aufgelistet
    local info = UIDropDownMenu_CreateInfo()  
    local tmp = DDME["selectedID"]
    for k,v in pairs(GD["MapIDS"][tmp]) do
        info = UIDropDownMenu_CreateInfo()
        if type(v) == "number" then
            info.text = GetMapNameByID(v)
        else
            info.text = v
        end
        info.value = v
        info.func = OnClickDDMI
        UIDropDownMenu_AddButton(info, level)
   end
   if #GD["Modul"][tmp] >= 1 then 
		for k,v in pairs(GD["Modul"][tmp]) do
			info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.value = v
			info.func = OnClickDDMI
			UIDropDownMenu_AddButton(info, level)
		end
	end
end
UIDropDownMenu_Initialize(DDMI, initializeDDMI)

----------------------------------------------------------------
----------------------------------------------------------------- C & S
-----------------------------------------------------------------

local function OnClickDDMS(self,event,arg1)                --- Spec ausgewhlt
    UIDropDownMenu_SetSelectedID(DDMS, self:GetID())
	DDMS["selectedValue"] = self.value
	ClearItemButtons()
	LootAbfrageStart()
	hideWishList()
end

local function initializeDDMS(self, level)         -- Specs  Wird genereirt  (muss leider hier stehen :-()
	local class = DDMC["selectedValue"]
    local info = UIDropDownMenu_CreateInfo()
	
	if class == 0 then  ---keine Specs anzeigen
		UIDropDownMenu_SetText(DDMS, GL["All"], 0)
	else
		for k,v in pairs(GD["ClassSpecs"][class]) do
			info = UIDropDownMenu_CreateInfo()
			info.text = GLW["Specs"][v]
			info.value = v
			info.func = OnClickDDMS
			UIDropDownMenu_AddButton(info,1)
		end
	end
end

local function OnClickDDMC(self)                --- Class wurde ausgewhlt
    UIDropDownMenu_SetSelectedID(DDMC, self:GetID())
	DDMC["selectedValue"] = self.value
	ClearItemButtons()
	LootAbfrageStart()
	hideWishList()
	UIDropDownMenu_Initialize(DDMS, initializeDDMS)
end

local function initializeDDMC(self, level)          -- Klassen werden aufgelistet
    local info = UIDropDownMenu_CreateInfo()  
	
		info = UIDropDownMenu_CreateInfo()
        info.text = GL["All"]
		info.value = 0
        info.func = OnClickDDMC
        UIDropDownMenu_AddButton(info, level)
	
    for i=2, GetNumClasses() do
        info = UIDropDownMenu_CreateInfo()
        info.text = GetClassInfo(i) 
		info.value = i
        info.func = OnClickDDMC
        UIDropDownMenu_AddButton(info, level)
    end
end
UIDropDownMenu_Initialize(DDMC, initializeDDMC)


